#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>

#define NN 16

int main()
{
FILE *first;
FILE *second;
int n,i;
int c;
static int table[NN]={119,7,48,150,238,14,97,44,153,9,81,186,7,109,196,25};


first = fopen("Adom","r");

if (first == NULL)
    fprintf(stderr,"Can't open 'Adom' executable for input -\n");
else
    {
    n=0;
    while ( ((c=fgetc(first)) != EOF) && (n<NN) )
        if (c == table[n])
            ++n;
        else
            n=0;
    if ( n < NN )
        fprintf(stderr,"CRC table not found.\nThe executable may already be patched\nor your version may not have CRC check.\nyou can report to bfanchon@ens-lyon.fr\n");
    else
        {
        n=0;
        while ( ((c=fgetc(first)) != EOF) && (n<NN) )
            if (c == table[n])
                ++n;
            else
                n=0;
        if ( n == NN )
            fprintf(stderr,"Two CRC tables found !\nNot able to choose.\nPlease report to bfanchon@ens-lyon.fr\n");
        else
            {
            rewind (first);
            second = fopen("AdomPatched","w");
            if (second == NULL)
                fprintf(stderr,"Write error\nCan't open patched executable for output -\n");
            else
                {
                n=0;
                while ( ((c=fgetc(first)) != EOF) && (n<NN) )
                    if (c == table[n])
                        ++n;
                    else
                        {
                        for (i=0;i<n;++i)
                            fputc(table[i],second);
                        n=0;
                        fputc(c,second);
                        }
                if (n != NN)
                    fprintf( stderr,"Erreur grossiere de recopie\n");
                else
                    {
                    for (i=0;i<1024;++i)
                        fputc(0,second);
                    for (i=NN+1;i<1024;++i)
                        c=fgetc(first);
                    }
                while ((c=fgetc(first)) != EOF)
                    fputc (c,second);
                fclose (second);
                system ("rename Adom AdomOld");
                system ("rename AdomPatched Adom");
                system ("copy Adom.info AdomOld.info");
                fprintf(stdout,"Work finish.\nAdom backuped as AdomOld.\n");
                }
            }
        }
    fclose (first);
    }
return 0;
}